#include	<ext.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	<time.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"
#include	"cont_pat.h"
#include	"windinfo.h"


extern OBJECT *adr_strings, *secret_change_info;
extern X_GEM_INFO *x_gem;
extern struct opt options;

void Replace_text (char *src, char *text1, char *text2);

void Pack_date(char *date)
	{
	unsigned int time;
	int heu, min, sec;
	int year, month, day;

	time = Tgettime ();									/* calculer l'heure */
	heu = ((time >> 11) & 0x1f);
	min = (time >> 5) & 0x3f;
	sec = (time & 0x1f) << 1;

	time = Tgetdate ();
	year = 1980 + ((time >> 9) & 0x7f);
	month = (time >> 5) & 0xf;
	day = (time & 0x1f);

	if(date)
		{
		sprintf(date, "D:");
		sprintf (date, "D:%04i%02i%02i%02i%02i%02i", year, month, day, heu, min, sec);
		}
	}


#define GET_INFO	{				if(pdf_info->Title)		\
					free(pdf_info->Title);		\
				pdf_info->Title = calloc(1, strlen(x_get_ob_text(secret_change_info, E_CHANGE_TITEL)+10));		\
				strcpy(pdf_info->Title, x_get_ob_text(secret_change_info, E_CHANGE_TITEL));		\
				Replace_text (pdf_info->Title, "(", "\\(");		\
				Replace_text (pdf_info->Title, ")", "\\)");		\
				if(pdf_info->Author)		\
					free(pdf_info->Author);		\
				pdf_info->Author = calloc(1, strlen(x_get_ob_text(secret_change_info, E_CHANGE_AUTHOR)+10));		\
				strcpy(pdf_info->Author, x_get_ob_text(secret_change_info, E_CHANGE_AUTHOR));		\
				Replace_text (pdf_info->Author, "(", "\\(");		\
				Replace_text (pdf_info->Author, ")", "\\)");		\
				if(pdf_info->Subject)		\
					free(pdf_info->Subject);		\
				pdf_info->Subject = calloc(1, strlen(x_get_ob_text(secret_change_info, E_CHANGE_SUBJECT)+10));		\
				strcpy(pdf_info->Subject, x_get_ob_text(secret_change_info, E_CHANGE_SUBJECT));		\
				Replace_text (pdf_info->Subject, "(", "\\(");		\
				Replace_text (pdf_info->Subject, ")", "\\)");		\
				if(pdf_info->Keywords)		\
					free(pdf_info->Keywords);		\
				pdf_info->Keywords = calloc(1, strlen(x_get_ob_text(secret_change_info, E_CHANGE_KEYWORD)+10));		\
				strcpy(pdf_info->Keywords, x_get_ob_text(secret_change_info, E_CHANGE_KEYWORD));		\
				Replace_text (pdf_info->Keywords, "(", "\\(");		\
				Replace_text (pdf_info->Keywords, ")", "\\)");		\
				if(pdf_info->Creator)		\
					free(pdf_info->Creator);		\
				pdf_info->Creator = calloc(1, strlen(x_get_ob_text(secret_change_info, E_CHANGE_CREATOR)+10));		\
				strcpy(pdf_info->Creator, x_get_ob_text(secret_change_info, E_CHANGE_CREATOR));		\
				Replace_text (pdf_info->Creator, "(", "\\(");		\
				Replace_text (pdf_info->Creator, ")", "\\)");		\
				if(pdf_info->Producer)		\
					free(pdf_info->Producer);		\
				pdf_info->Producer = calloc(1, strlen(x_get_ob_text(secret_change_info, E_CHANGE_PRODUC)+10));		\
				strcpy(pdf_info->Producer, x_get_ob_text(secret_change_info, E_CHANGE_PRODUC));		\
				Replace_text (pdf_info->Producer, "(", "\\(");		\
				Replace_text (pdf_info->Producer, ")", "\\)");		\
				}



BOOLEAN Change_document_info(WIND_INFO *wind_info)
	{
	struct PDF_Info *pdf_info=wind_info->pdf_info;
	DIAL_INFO dial;
	int obj, handle;
	size_t pos;
	char *text;

	if(pdf_info->CreationDate==NULL || strlen(pdf_info->CreationDate)==0)
		{
		if(x_gem_alert(x_get_ob_text(adr_strings, SECRET_TXT_DATE), 0L)==1)
			{
			pdf_info->CreationDate = calloc(1, 30);
			Pack_date(pdf_info->CreationDate);
			}
		}

	if(pdf_info->Title)
		strncpy(x_get_ob_text(secret_change_info, E_CHANGE_TITEL), pdf_info->Title, (strlen(pdf_info->Title) < 60) ? strlen(pdf_info->Title) : 60);
	if(pdf_info->Author)
		strncpy(x_get_ob_text(secret_change_info, E_CHANGE_AUTHOR), pdf_info->Author, (strlen(pdf_info->Author) < 60) ? strlen(pdf_info->Author) : 60);
	if(pdf_info->Subject)
		strncpy(x_get_ob_text(secret_change_info, E_CHANGE_SUBJECT), pdf_info->Subject, (strlen(pdf_info->Subject) < 60) ? strlen(pdf_info->Subject) : 60);
	if(pdf_info->Keywords)
		strncpy(x_get_ob_text(secret_change_info, E_CHANGE_KEYWORD), pdf_info->Keywords, (strlen(pdf_info->Keywords) < 60) ? strlen(pdf_info->Keywords) : 60);
	if(pdf_info->Creator)
		strncpy(x_get_ob_text(secret_change_info, E_CHANGE_CREATOR), pdf_info->Creator, (strlen(pdf_info->Creator) < 60) ? strlen(pdf_info->Creator) : 60);
	if(pdf_info->Producer)
		strncpy(x_get_ob_text(secret_change_info, E_CHANGE_PRODUC), pdf_info->Producer, (strlen(pdf_info->Producer) < 60) ? strlen(pdf_info->Producer) : 60);

	x_open_dial (secret_change_info, &dial, 0, 0, 0L);

	for (;;)												/* classic xgem loop... */
	{
		x_form_do (&dial);

		if (x_gem->event & MU_BUTTON)
		{
			obj = *x_gem->object;
			if (obj == E_CHANGE_OK)
				{
				GET_INFO
				break;
				}
			else if (obj == E_CHANGE_SAVE)
				{
				GET_INFO

				secret_change_info[E_CHANGE_SAVE].ob_state &= ~SELECTED;
				s_objc_draw (secret_change_info, E_CHANGE_SAVE, MAX_DEPTH, &x_gem->desk_size);

				text = calloc(1, 4096);
				if(x_file_select (1, STR (DI_OPEN), "*.PDF", options.paths.default_pdf_dir, text))
					{
					handle = open(text, O_WRONLY|O_TRUNC|O_CREAT);
					if(handle>0)
						{
						write(handle, pdf_info->file_info->buffer, pdf_info->file_info->buff_size);
						close(handle);
						handle = open(text, O_WRONLY);
						pos = Fseek(0, handle, 2);

						if(pdf_info->ModDate)
							free(pdf_info->ModDate);
						pdf_info->ModDate = calloc(1, 30);
						Pack_date(pdf_info->ModDate);
						sprintf(text, "%d 0 obj\r\n<<\r\n/Title (%s)\r\n/Author (%s)\r\n/Keywords (%s)\r\n/Subject (%s)\r\n/Creator (%s)\r\n/Producer (%s)\r\n/CreationDate (%s)\r\n/ModDate (%s)\r\n>>\r\nendobj\r\n",	\
													pdf_info->Info_object, pdf_info->Title, pdf_info->Author, \
													pdf_info->Keywords, pdf_info->Subject, pdf_info->Creator, pdf_info->Producer, pdf_info->CreationDate, pdf_info->ModDate);

						write(handle, text, strlen(text));
						memset(text, 0, 4096);

						sprintf(text, "xref\r\n%d 1\r\n%010Ld 00000 n\r\n", pdf_info->Info_object, (unsigned long)pos);
						pos = Fseek(0, handle, 2);
						write(handle, text, strlen(text));
						memset(text, 0, 4096);

						sprintf(text, "trailer\r\n<<\r\n/Size %d\r\n/Prev %Ld\r\n/Root %d 0 R\r\n/Info %d 0 R\r\n/ID[<4d75e596e05975720a56484fc428623f><3e684dbfb37f5b8679427c8a5d4174db>]\r\n>>\nstartxref\r\n%Ld\r\n", \
								(int)pdf_info->trailer->Size, (unsigned long)pdf_info->pos_xref, (int)pdf_info->trailer->Root_object, pdf_info->Info_object, pos);
						write(handle, text, strlen(text));
						write(handle, "%%EOF\r\n", strlen("%%EOF\r\n"));

						close(handle);
						}
					}
				free(text);
				break;
				}
			else if (obj == E_CHANGE_CANCEL)
				break;
		}
	}

	x_close_dial (&dial, obj);
	return(TRUE);
	}