#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<zlib.h>
#include	<aes.h>
#include	"mp_const.h"
#include	"memdebug.h"
#include	"status.h"

extern struct opt options;


void ani_mouse (void);
void Change_progress_bar (int status, int window, unsigned long value, unsigned long max_value);

short x_gem_alert (char *, OBJECT *icn);


#define CHECK_ERR(err, msg) { \
    if (err != Z_OK) { \
        sprintf(error, "[1][%s error: %s][[Oops|[Exit]", msg, inflate_err[abs(err)]); \
        if(x_gem_alert(error, 0L)==2) \
        	exit(0);		\
    } \
}


void expand_inflate(int window, char *input, char *output, unsigned long max_size_in, unsigned long max_size_out, unsigned long *output_pos)
	{
	int err=0;
	z_stream d_stream;						/* decompression stream */
	char error[64]={0};
	char *inflate_err[]={"unknown error", "Errno", "Stream error", "Data error", "Memory error", "Buffer error", "Version error", NULL};

	Change_progress_bar (STATUS_PDF_UNCOM_INFLATE, window, 0, 0);

	d_stream.zalloc = (alloc_func)calloc;
	d_stream.zfree = (free_func)free;
	d_stream.opaque = (voidpf)0;

	d_stream.next_in  = input;
	d_stream.avail_in = 0;
	d_stream.next_out = output;

	err = (int)inflateInit(&d_stream);
	CHECK_ERR(err, "inflateInit");

	while (d_stream.total_out<max_size_out && d_stream.total_in<max_size_in)
		{
		Change_progress_bar (STATUS_BAR3_UPDATE, window, d_stream.total_in, max_size_in);
		ani_mouse ();

		d_stream.avail_in = d_stream.avail_out = 1;						/* force small buffers */
		err = inflate(&d_stream, Z_FULL_FLUSH);								/*	Z_NO_FLUSH);	*/
		if (err == Z_STREAM_END)
			break;
		CHECK_ERR(err, "Inflate");
		}

	(*output_pos) = d_stream.total_out;
	err = inflateEnd(&d_stream);
	CHECK_ERR(err, "inflateEnd");
	}
