typedef struct graphical_state
	{
	int how_many, number;
	struct _CTM
		{
		signed long a, b, c, d, e, f;
		}CTM;
	long clipping_path;
	long color_space;
	long color;
	long text_space;
	long line_width;
	long line_cap;
	long line_join;
	long miter_limit;
	long dash_patter[18];
	long rendering_intent;
	short line_type;
	short line_color;
	short fill_color;
	BOOLEAN stroke_adjustment;
	signed long pos_x, pos_y;								/* Position of the pen on the screen (UserSpaceUnits) */
	short rgb[3];
	short cmyk[4];
	struct graphical_state *next_graf_state;
	struct graphical_state *prev_graf_state;
	};

#define GRAPH_STATE