#include	<ext.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"


extern X_GEM_INFO *x_gem;


int	av_shell_id = -1,					/* Desktop's ID 										*/
		av_shell_status = 0;			/* What AV Commands can desktop do?	*/


int Send_AV(int to_ap_id, int message, char *data1, char *data2)
	{
	int *msg=NULL;

	data2 = data2;

	msg = calloc(1, 16);							/* This must be set to GLOBAL (available for all applications - under Memory Protection)	*/

	if(msg!=NULL && to_ap_id>=0)
		{
		if(to_ap_id==0)
			to_ap_id = x_gem->ap_id;

		msg[0] = message;

		switch(message)
			{
			case PDF_AV_DONE_FALSE:						/* Sending the confirmation of loaded file	*/
			case PDF_AV_DONE_OK:
				msg[1] = x_gem->ap_id;
				msg[2] = 0;
				break;

			case PDF_AV_OPEN_FILE:
				msg[1] = x_gem->ap_id;
				msg[2] = 0;
				*(char **) (msg + 3) = data1;			
				break;

			case AV_EXIT:
				msg[1] = x_gem->ap_id;
				msg[3] = x_gem->ap_id;
				break;

			case AV_PROTOKOLL:
				msg[1] = x_gem->ap_id;
				msg[3] = (2|16);									/* VA_START, Quoting */
				*(char **) (msg + 6) = "MyPDF   ";
				break;

			default:
				msg[1] = x_gem->ap_id;
				msg[2] = 0;
				msg[3] = 0;
				break;
			}	

		if(appl_write(to_ap_id, 16, msg)!=0)
			{
			free(msg);
			return(1);
			}
		else
			{
			free(msg);
			return(0);
			}
		}
	else
		{
		return(0);
		}
	}


int Receive_AV(void)
	{
	return(0);
	}


static void send_avprot(void)
	{
	if (av_shell_id >= 0)
		Send_AV(av_shell_id, AV_PROTOKOLL, NULL, NULL);
	}


void Init_AV_Protocol(void)
	{
	int	i;
	char	name[9], *p;

	p = getenv("AVSERVER");													/* Is there any AV Server?	*/
	if (p != NULL)																	/* yes											*/
		{
		strncpy(name, p, 8);													/* Copy it's name						*/
		name[8] = 0;
		for (i = (int)strlen(name); i < 8; i++)				/* If the name is shorter then 8	*/
			strcat(name, " ");
		i = appl_find(name);													/* Find the AVSERVER application	*/
		if (i >= 0)
			av_shell_id = i;
		}
	send_avprot();
	}

void Exit_AV_Protocol(void)
	{
	if ((av_shell_id >= 0) && (av_shell_status & 1024))
		Send_AV(av_shell_id, AV_EXIT, NULL, NULL);
	}
